package com.pmguda.winexit;
import java.awt.BorderLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class WinExit extends javax.swing.JFrame {
	private JPanel jPanel1;
	private JButton jButtonCancel;
	private JLabel jLabelCastTime;
	private JPanel jPane_Statebar;
	private JEditorPane jEditorPaneAbout;
	private JMenuItem jMenuItemHelp;
	private JDialog jDialog1;
	private JMenuItem jMenuItem1;
	private JMenu jMenu2;
	private JMenu jMenu1;
	private JMenuBar jMenuBar1;
	private JTextArea jTextAreaLog;
	private JButton jButtonSetup;
	private JComboBox jComboBoxSetup;
	private JLabel jLabelMin;
	private JTextField jTextTime;
	
	private ClockLabel clockLabel;
	private Timer timer;
	
	private WinProc winproc;
	private static final String version = "WinExit 1.2.1v";
	private static final String title = " "+ version +" (pmguda.com)";
	/**
	* Auto-generated main method to display this JFrame
	*/
	public static void main(String[] args) {
		WinExit inst = new WinExit();
		inst.setVisible(true);
		new WinTray(inst,title);
	}
	
	public WinExit() {
		
		super();
		winproc = new WinProc();
		if(winproc.countProc() > 1) { System.exit(0);}
		initGUI();
	}
	
	private void initGUI() {
		try {
			Image image = Toolkit.getDefaultToolkit().getImage("image/tray.gif");
			this.setTitle(title);
			this.setIconImage(image);
			this.setLocation(new java.awt.Point(200, 200));
			this.setResizable(false);
			{
				jMenuBar1 = new JMenuBar();
				setJMenuBar(jMenuBar1);
				jMenuBar1.setPreferredSize(new java.awt.Dimension(272, 20));
				{
					jMenu1 = new JMenu();
					jMenuBar1.add(jMenu1);
					jMenu1.setText("File");
					jMenu1.addActionListener(exitListener);
					{
						jMenuItem1 = new JMenuItem();
						jMenu1.add(jMenuItem1);
						jMenuItem1.setText("Exit");
						jMenuItem1.addActionListener(exitListener);
					}
				}
				{
					jMenu2 = new JMenu();
					jMenuBar1.add(jMenu2);
					jMenu2.setText("Help");
					jMenu2.add(getJMenuItemHelp());
				}
			}
			{
				jPanel1 = new JPanel();
				BoxLayout jPanel1Layout = new BoxLayout(jPanel1,javax.swing.BoxLayout.X_AXIS);
				jPanel1.setLayout(jPanel1Layout);
				getContentPane().add(jPanel1, BorderLayout.NORTH);
				{
					jTextTime = new JTextField();
					jPanel1.add(jTextTime);
					jTextTime.setText("0");
					jTextTime.setColumns(3);
					jTextTime.selectAll();
					jTextTime.setHorizontalAlignment(JTextField.RIGHT );
					jTextTime.addKeyListener(new TimeListener());
					//jTextTime.addKeyListener(new TimeListener());
				}
				{
					jLabelMin = new JLabel();
					jPanel1.add(jLabelMin);
					jLabelMin.setText(" Min ");
				}
				{
					ComboBoxModel jComboBoxSetupModel = new DefaultComboBoxModel(
						new String[] { "ý ", "ý " });
					jComboBoxSetup = new JComboBox();
					jPanel1.add(jComboBoxSetup);
					jComboBoxSetup.setModel(jComboBoxSetupModel);
				}
				{
					jButtonSetup = new JButton();
					jPanel1.add(jButtonSetup);
					jButtonSetup.setText("setting");
					jButtonSetup.addActionListener(new ScheduleLisner());
				}
				{
					jButtonCancel = new JButton();
					jPanel1.add(jButtonCancel);
					jButtonCancel.setText("Cancel");
					jButtonCancel.addActionListener(new CancelListener());
				}
			}
			{
				jTextAreaLog = new JTextArea(3,23);
				jTextAreaLog.setText("");
				jTextAreaLog.setWrapStyleWord(true);
				JScrollPane Jscroller = new JScrollPane(jTextAreaLog);
				Jscroller.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
				getContentPane().add(Jscroller, BorderLayout.CENTER);
			}
			{
				jPane_Statebar = new JPanel();
				BorderLayout jPanel2Layout = new BorderLayout();
				jPane_Statebar.setLayout(jPanel2Layout);
				jPane_Statebar.setBorder(BorderFactory.createMatteBorder(1, 1, 1, 1, new java.awt.Color(0,0,0)));
				getContentPane().add(jPane_Statebar, BorderLayout.SOUTH);
				{
					jLabelCastTime = new JLabel();
					jPane_Statebar.add(jLabelCastTime, BorderLayout.WEST);
					jLabelCastTime.setHorizontalAlignment(SwingConstants.LEFT);
					jLabelCastTime.setPreferredSize(new java.awt.Dimension(170, 17));
				}
				{
				clockLabel = new ClockLabel(); 
			        clockLabel.setOpaque(true); 
			        jPane_Statebar.add(clockLabel, BorderLayout.EAST);
					clockLabel.setHorizontalAlignment(SwingConstants.RIGHT);
					clockLabel.setPreferredSize(new java.awt.Dimension(100, 17));
					/////ClockLabel  ð  //
					Thread timeThread = new Thread(clockLabel);
			        timeThread.start();
				}
			}
			pack();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private JDialog getJDialog1() {
		if(jDialog1 == null) {
			jDialog1 = new JDialog(this);
			jDialog1.setTitle("About " + version);
			jDialog1.setLocation(new java.awt.Point(230, 230));
			jDialog1.setModal(true);
			jDialog1.setResizable(false);
			{
				JLabel jLabelImg = new JLabel(new ImageIcon("image/help.jpg"));
				jDialog1.getContentPane().add(jLabelImg, BorderLayout.WEST);
				jDialog1.getContentPane().add(getJEditorPaneAbout(), BorderLayout.EAST);
				jLabelImg.setOpaque(true);
			}
			jDialog1.pack();
		}
		return jDialog1;
	}
	
	private JMenuItem getJMenuItemHelp() {
		if(jMenuItemHelp == null) {
			jMenuItemHelp = new JMenuItem();
			jMenuItemHelp.setText("About");
			jMenuItemHelp.addActionListener(showDialog);
		}
		return jMenuItemHelp;
	}

	private JEditorPane getJEditorPaneAbout() {
		if(jEditorPaneAbout == null) {
			String about = title + "<br />" +
			"<P>(c) Copyright , 2008.&nbsp; All rights reserved.<br />Visit <A href=\"http://www.pmguda.com\">http://www.pmguda.com</A></P>" +
			"<P>This product includes software developed by the<br />guda Software Foundation <A href=\"http://www.pmguda.com/\">http://www.pmguda.com/</A></P>";
			jEditorPaneAbout = new JEditorPane("text/html",about);
			jEditorPaneAbout.setEditable(false);
			/*
			 *  θ ֱ
			 */
			jEditorPaneAbout.addHyperlinkListener(new LinkFollower());
		}
		return jEditorPaneAbout;
	}

////////////̺Ʈ  /////////////////////
	class TimeListener implements KeyListener {
		public void keyPressed(KeyEvent event){};
		public void keyReleased(KeyEvent event){};
		public void keyTyped(KeyEvent event)	{
			char pushKey = event.getKeyChar();
			if(!(Character.isDigit(pushKey)||	pushKey== KeyEvent.VK_BACK_SPACE||pushKey== KeyEvent.VK_DELETE) ) {
				JOptionPane.showMessageDialog(null, "ڸ Է մϴ.", "ð", JOptionPane.WARNING_MESSAGE);
				event.consume();   //̺Ʈ ҸŰ.
			      
			}
		}		
	}
	
	class ScheduleLisner implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			// Ȯ â ٿ.
			if(jTextTime.getText().equals("0")){
				int check = JOptionPane.showConfirmDialog(null, " ٷ Ͻðڽϱ?", "Ȯ",JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
				if(check != 0) return;
			}
			
			if(timer == null) {
				timer = new Timer(); 
			}	else {
				timer.cancel();
				jTextAreaLog.append("  ҵǾϴ.\n");
				timer = new Timer(); 
			}
			
			jTextAreaLog.append("[" + clockLabel.hour + ":" + clockLabel.min + ":" + clockLabel.sec + "] ");
			
			//Όð 
			SimpleDateFormat sdf = new SimpleDateFormat(" HHmm");
			String casttime = sdf.format(new Date(clockLabel.calendar.getTimeInMillis() + Integer.parseInt(jTextTime.getText())*60000));
			//TimerTask,   1000 1
			if(jComboBoxSetup.getSelectedIndex() == 0)	{
				timer.schedule(new ExitTimerTask(" -r -t 0"),Integer.parseInt(jTextTime.getText())*60000); 	
				jTextAreaLog.append(jTextTime.getText() +  "  Ǿϴ.\n");
				jLabelCastTime.setText(casttime + "  ˴ϴ.");
			}	else		{
				timer.schedule(new ExitTimerTask(" -s -t 0"),Integer.parseInt(jTextTime.getText())*60000); 	
				jTextAreaLog.append(jTextTime.getText() + "  Ǿϴ.\n");
				jLabelCastTime.setText(casttime + "  ˴ϴ.");
			}
		}
	}
	
	class CancelListener implements ActionListener {
		public void actionPerformed(ActionEvent event) {
			jTextAreaLog.append("[" + clockLabel.hour + ":" + clockLabel.min + ":" + clockLabel.sec + "] ");
			if(timer == null)	{
				jTextAreaLog.append( " ϴ.\n");
			} else {
			timer.cancel();
			timer = null;
			jTextAreaLog.append( "  Ǿϴ.\n");
			//Όð ʱȭ
			jLabelCastTime.setText("");
			}
		}
	}
	

	class ExitTimerTask extends TimerTask { 

		private String ExitOption , ExitCmd = "shutdown ";
		
		public ExitTimerTask(String Opcmd) { 
			this.ExitOption  = Opcmd; 
		}
		
		public void run() { 
			this.RunProc(ExitCmd + ExitOption);
		
		} 

		public void RunProc(String cmd) {
			try{
				String output, err;
				Process proc = Runtime.getRuntime().exec(cmd); 
				
				BufferedReader stdout = new BufferedReader(new InputStreamReader(proc.getInputStream()));
				BufferedReader stderr = new BufferedReader(new InputStreamReader(proc.getErrorStream())); 
				
				try {
					while((output = stdout.readLine()) != null) {
						jTextAreaLog.append(output + "\n");
					}
					while((err = stderr.readLine()) != null) {
						jTextAreaLog.append(err + "\n");
					}
				}
				catch(IOException e) {
					System.exit(0);
				}
			}
			catch(IOException ex) {
				System.err.println(ex);
				System.exit(1);
			}
		} //RunProc method
	} //ExitTimerTask class
	
////////// ̺Ʈ   //////////////////////
	ActionListener exitListener = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
           System.exit(0);
        }
    };
    
//////////̾α ̺Ʈ   //////////////////////
	ActionListener showDialog = new ActionListener() {
        public void actionPerformed(ActionEvent e) {
        	jDialog1 = getJDialog1();
        	jDialog1.setVisible(true);
        }
    };
}
